/**
 * MYP Platform UI Components
 * Erweiterte Benutzeroberfläche mit Glassmorphism-Effekten und Dark Mode
 */

(function() {
    'use strict';
    
    // Frühe showToast-Fallback-Definition zur Vermeidung von ReferenceErrors
    if (!window.showToast) {
        window.showToast = function(message, type = 'info', duration = 5000) {
            console.log(`🔧 Fallback showToast: [${type.toUpperCase()}] ${message}`);
            // Fallback: Verwende console.log wenn noch nicht richtig initialisiert
        };
    }
    
    // Namespace sicherstellen
    window.MYP = window.MYP || {};
    window.MYP.UI = window.MYP.UI || {};
    
    console.log('🎨 MYP UI Components werden geladen...');
})(); 