#!/usr/bin/env python3.11

from models import init_database, create_initial_admin

if __name__ == "__main__":
    print("Initialisiere Datenbank...")
    init_database()
    
    print("Erstelle initialen Admin-Benutzer...")
    success = create_initial_admin(
        email="admin@mercedes-benz.com",
        password="744563017196A",
        name="System Administrator",
        username="admin"
    )
    
    if success:
        print("Admin-Benutzer erfolgreich erstellt.")
        print("Login-Daten:")
        print("  Benutzername: admin")
        print("  Passwort: 744563017196A")
    else:
        print("Admin-Benutzer konnte nicht erstellt werden (existiert bereits?).")
    
    print("Datenbank-Initialisierung abgeschlossen.") 