/** @type {import('next').NextConfig} */
const nextConfig = {
  reactStrictMode: true,
  webpack: (config) => {
    return config;
  },
  // Zusätzliche Konfigurationen für Backend-Weiterleitung
  async rewrites() {
    return [
      {
        source: '/api/:path*',
        destination: 'https://raspberrypi:443/api/:path*',
      },
    ]
  }
};

module.exports = nextConfig;
